<%@ Page Language="c#" %>

<!--
    A quick and dirty 404 handler for a missing tiles when acessing a MapGuide 
    tiled map served directly by IIS.

    It's a dirty dot net port of getTile.php

      Example URL:
  http://localhost:8008/sheboyganTiles/S13/Base Layer Group/R4/C4/11_7.png

  Note:
  1. This script does not handle extra parameters, i.e. the "querystring"
     parameter added under http://trac.openlayers.org/ticket/1622.
  2. You must hard-code the tile map repository definition and access
     credentials inside this file.

  Configuration:
  1. In IIS select the virtual folder containing the tile cache, right-click and
     select Properties.
  2. In the Properties dialog, select the Custom Errors tab.
  3. Choose 404 from the list and click Edit.
  4. In the Edit Custom Error Properties dialog choose URL for Message Type and 
     enter a relative path to this PHP file, e.g. "/mapguide/blah/getTile.aspx?mapDefinition=<URL Encoded Map Definition>".
  5. Save this file in the relevant location, e.g. 
     "C:\Program Files\MapGuideOpenSource2.0\WebServerExtensions\www\mapviewernet\getTile.aspx".

-->

<%@ Import Namespace="System" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.Collections.Specialized" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="OSGeo.MapGuide" %>

<!-- #Include File="common.aspx -->
<!-- #Include File="product.aspx -->
<script language="C#" runat="server">
    string sessionId = "";
    string tileUser = "Anonymous";
    string tilePassword = "";
    string tileMap = "";
    string baseMapLayerGroupName = "";
    string imgFile = "";
    int scaleIndex, groupCol, groupRow, fileRow, fileCol, tileRow, tileCol = 0;
</script>

<%
    try
    {
        //Process the request parameters
        // Anticipated example REQUEST_URI:
        // "/httpmaptest/tiles/getTile.php?mapDefinition=Library://Samples/Sheboygan/MapsTiled/Sheboygan.MapDefinition&404;http://localhost:80/httpmaptest/tiles/S5/Base Layer Group/R30/C0/0_6.png"
        string[] ar_path = Request.Params["QUERY_STRING"].Split('/');
        tileMap = Request.Params["mapDefinition"];
        // Pick off what we need from the right-hand side, working left.
        int pathLength = ar_path.Length;
        imgFile = ar_path[pathLength - 1];
        groupCol = int.Parse(ar_path[pathLength - 2].Substring(1, ar_path[pathLength - 2].Length - 1));
        groupRow = int.Parse(ar_path[pathLength - 3].Substring(1, ar_path[pathLength - 3].Length - 1));
        baseMapLayerGroupName = ar_path[pathLength - 4];
        scaleIndex = int.Parse(ar_path[pathLength - 5].Substring(1, ar_path[pathLength - 5].Length - 1));
        string[] ar_file = imgFile.Split('_');
        fileRow = int.Parse(ar_file[0]);
        fileCol = int.Parse(ar_file[1].Split('.')[0]);
        tileRow = groupRow + fileRow;
        tileCol = groupCol + fileCol;

        Response.Charset = "utf-8";
        //MgLocalizer.SetLocalizedFilesPath(Request.ServerVariables["APPL_PHYSICAL_PATH"] + "..\\localized\\");

        // Initialize web tier with the site configuration file.
        InitializeWebTier();

        // Connect to the site as the chosen user.
        MgUserInformation user = new MgUserInformation(tileUser, tilePassword);
        MgSiteConnection siteConnection = new MgSiteConnection();
        siteConnection.Open(user);

        // Set up the tiling service.
        MgTileService tileService = (MgTileService)siteConnection.CreateService(MgServiceType.TileService);

        // Fetch the image.
        MgResourceIdentifier tileResource = new MgResourceIdentifier(tileMap);
        MgByteReader byteReader = tileService.GetTile(tileResource, Server.UrlDecode(baseMapLayerGroupName), tileCol, tileRow, scaleIndex);

        // Output the image contents.
        byte[] buffer = new byte[1024];
        Response.AddHeader("Content-Type", "image/png");
        while (byteReader.Read(buffer, 1024) != 0)
        {
            Response.BinaryWrite(buffer);
        }



    }
    catch (Exception ne)
    {
        String errorMsg = EscapeForHtml(ne.ToString());
        Response.Write(errorMsg);
    }
%>
